%find Inodes and approximate adjusted edge thickness
function [Inode,w] = Inodes(f,Bnode,r,m)

[M,N] = size(f);
ish = floor(max(M,N)/50);
pad = 4;
ipad = 4;
%fac = 1.3; %increase if too many interior nodes
fac = 1.4;  %fudge factor

if (nargin < 4)
   m = M;
end

%get rid of boundary nodes
for k = 1:length(Bnode)
   f(Bnode(k).i-2*r-pad:Bnode(k).i+2*r+pad,Bnode(k).j-2*r-pad:Bnode(k).j+2*r+pad) = 0;
end

%just work with points on the remaining graph
p = find(f==1);

h = zeros(length(p),1);
%estimate approx thickness
for k = 1:length(p)
   j = floor((p(k)-1)/M)+1; %column
   i = p(k) - M*(j-1); %row      
   h(k) = mean(mean( f(i-r:i+r,j-r:j+r) ));
end  
w = round(median(h)*(2*r+1)); %thickness estimate
for k = 1:length(p)
   j = floor((p(k)-1)/M)+1; %column
   i = p(k) - M*(j-1); %row      
   h(k) = mean(mean( f(i-w:i+w,j-w:j+w) ));
end  


%remove edges (or not)
if (nargin < 4)
   Ih = find(h>fac*w/(2*w+1));  %fudge factor alert
else
   Ih = 1:length(p); %if num int nodes known
end

%make sure we find something
[sh, Ish] = sort(h(Ih));
q = length(sh);
while (q == 0)
   fac = fac*.95;
   Ih = find(h>fac*w/(2*w+1));
   [sh, Ish] = sort(h(Ih));
   q = length(sh);
end

if (m == 0)
   Inode = [];
   mtot = 0;
else
   iind = 1;
   Inode(iind).ind = p(Ih(Ish(q)));
   Inode(iind).j = floor((p(Ih(Ish(q)))-1)/M)+1;
   Inode(iind).i = p(Ih(Ish(q))) - M*(Inode(iind).j-1);
   mtot = 1;
   
   
   for q = length(sh)-1:-1:1      
      temp.ind = p(Ih(Ish(q)));
      temp.j = floor((p(Ih(Ish(q)))-1)/M)+1;
      temp.i = p(Ih(Ish(q))) - M*(temp.j-1);
      
      dist2 = zeros(length(Inode),1);
      for l = 1:length(dist2)
         dist2(l) = (temp.i-Inode(l).i)^2 + (temp.j-Inode(l).j)^2;
      end
      if ( min(dist2)>((4*w+ipad)^2) & mtot<m)
         iind = iind + 1;
         Inode(iind).ind = temp.ind;
         Inode(iind).j = temp.j;
         Inode(iind).i = temp.i;
         mtot = mtot + 1;
      end
   end
   
   %order the interior nodes
   clear ind;
   for k = 1:length(Inode)
      ind(k) = Inode(k).ind;
   end
   [sind, Isind] = sort(ind);
   for k = 1:length(Inode)
      oinode(k) = Inode(Isind(k));
   end
   Inode = oinode;
   
   %visualization
   bn = length(Bnode);
   figure(42)
   for (t = 1:length(Inode))
      hold on
      rectangle('Position',[Inode(t).j-ish,Inode(t).i-ish,2*ish,2*ish],'Curvature',[1,1],...
         'FaceColor','y');
      daspect([1,1,1]);
      text(Inode(t).j,Inode(t).i,num2str(t+bn),'HorizontalAlignment','center',...
         'FontWeight','bold','color',[0 0 0]);
   end
end









